#pragma once

#if defined WIN32 || defined _WIN32

#define _CRT_SECURE_NO_WARNINGS
#include <windows.h>
#define __FORCEINLINE __forceinline

#elif defined __linux || defined __linux__

#define __FORCEINLINE __inline__

#endif

#include <cstdio>
#include <cstring>
#include <cerrno>
#include <cmath>
#include <cassert>
#include <stdint.h>

#include <string>
#include <vector>
#include <algorithm>
#include <functional>
#include <sstream>
#include <iostream>
#include <fstream>
#include <iterator>

#ifndef DEBUG_ERROR
#define DEBUG_ERROR(p)      { printf("%s line %d: %s", __FILE__, __LINE__, p);  }
#endif	
